# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.ContactListings do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :AgentNotesUnreadYN,
    :ContactNotesUnreadYN,
    :DirectEmailYN,
    :ListingViewedYN,
    :ContactKeyNumeric,
    :ContactListingsKeyNumeric,
    :ListingKeyNumeric,
    :ContactKey,
    :ContactListingsKey,
    :ContactLoginId,
    :ListingId,
    :ListingKey,
    :ClassName,
    :ContactListingPreference,
    :ResourceName,
    :LastAgentNoteTimestamp,
    :LastContactNoteTimestamp,
    :ListingModificationTimestamp,
    :ListingSentTimestamp,
    :ModificationTimestamp,
    :PortalLastVisitedTimestamp,
    :Contact,
    :Property
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :AgentNotesUnreadYN => boolean() | nil,
    :ContactNotesUnreadYN => boolean() | nil,
    :DirectEmailYN => boolean() | nil,
    :ListingViewedYN => boolean() | nil,
    :ContactKeyNumeric => float() | nil,
    :ContactListingsKeyNumeric => float() | nil,
    :ListingKeyNumeric => float() | nil,
    :ContactKey => String.t | nil,
    :ContactListingsKey => String.t | nil,
    :ContactLoginId => String.t | nil,
    :ListingId => String.t | nil,
    :ListingKey => String.t | nil,
    :ClassName => String.t | nil,
    :ContactListingPreference => String.t | nil,
    :ResourceName => String.t | nil,
    :LastAgentNoteTimestamp => Date.t | nil,
    :LastContactNoteTimestamp => Date.t | nil,
    :ListingModificationTimestamp => Date.t | nil,
    :ListingSentTimestamp => Date.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :PortalLastVisitedTimestamp => Date.t | nil,
    :Contact => FoyerAPI.Model.Contacts.t | nil,
    :Property => FoyerAPI.Model.Property.t | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.ContactListings do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:LastAgentNoteTimestamp, :date, nil, options)
    |> deserialize(:LastContactNoteTimestamp, :date, nil, options)
    |> deserialize(:ListingModificationTimestamp, :date, nil, options)
    |> deserialize(:ListingSentTimestamp, :date, nil, options)
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:PortalLastVisitedTimestamp, :date, nil, options)
    |> deserialize(:Contact, :struct, FoyerAPI.Model.Contacts, options)
    |> deserialize(:Property, :struct, FoyerAPI.Model.Property, options)
  end
end

